  
  //steuert den Arduino
  //bewegt den Elektromagneten
  //visualisiert den Lösungsweg auf dem Spielfeld
  
  //Pinbelegung des Arduino
  int dirPinX = 2;
  int stepPinX = 3;
  int dirPinY = 6;
  int stepPinY = 7;
  int dirPinEM = 4;
  int stepPinEM = 5;
  int pinEM = 8;
  
  //Distanz zwischen 2 Punkten des Lösungswegs und Anpassung der Pulses
  int distX = 0;
  int distY = 0;
  int distMultiplier = 145;
  int distStart = 330;
  
  //Strecke, um die der Magnet gehoben wird
  int magnetHeight = 200;
  
  //Richtungen des Magneten
  int down = 0;
  int up = 1;


  //Bewegen des Magneten um bestimmte Distanz in x-Richtung
void moveX(float dist, int dir) {
  
  arduino.digitalWrite(dirPinX, dir);
  float pulses = dist;
  
  for ( int i = 0; i < pulses; i++) {
    arduino.digitalWrite(stepPinX, Arduino.HIGH);
    delay(1);
    arduino.digitalWrite(stepPinX, Arduino.LOW);
    delay(1);
  }
}
  
  //Bewegen des Magneten um bestimmte Distanz in y-Richtung
void moveY(float dist, int dir) {
  
  arduino.digitalWrite(dirPinY, dir);
  float pulses = dist;
  
  for ( int i = 0; i < pulses; i++) {
    arduino.digitalWrite(stepPinY, Arduino.HIGH);
    delay(1);
    arduino.digitalWrite(stepPinY, Arduino.LOW);
    delay(1);
  }
}

  //Anheben oder Absenken des Magneten
void magnet(int dir) {
  
  arduino.digitalWrite(dirPinEM, dir);
  
  for ( int i = 0; i < magnetHeight; i++) {
    arduino.digitalWrite(stepPinEM, Arduino.HIGH);
    delay(1);
    arduino.digitalWrite(stepPinEM, Arduino.LOW);
    delay(1);
  }
}

void move() {
 
  println("prepare for moving");
  
  magnet(up);
  delay(500);

  //Austauschen der Scheiben vom ersten bis zum vorletzen Punkt des Lösungswegs
  for(int i = solutionCount - 1; i >= 0; i--) {
    
    println("started moving" + "\t" + i);
    
    magnet(down);
    arduino.digitalWrite(pinEM, Arduino.HIGH);
    delay(500);
    magnet(up);
    delay(500);
    
    distX = (11 - xPos[i]) * distMultiplier + distStart;
    distY = (10 - yPos[i]) * distMultiplier;
    
    println(distX + "\t" + distY);
    
    moveX(distX, 1);
    delay(500);
    moveY(distY, 1);
    delay(500);
    
    magnet(down);
    delay(500);
    
    arduino.digitalWrite(pinEM, Arduino.LOW);
    delay(500);
    
    magnet(up);
    delay(500);
    
    moveX(distX, 0);
    delay(500);
    moveY(distY, 0);
    delay(500);
    
    println("finished moving" + "\t" + i);
    
  }

   println("finished.");
   println("needed time: " + m + "\t" + s);
   noLoop();
  
}